/* libbreezy.c
 *
 * Copyright 2021 Gustav Hartvigsson
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libbreezy.h"
#include "libbreezy_private.h"

BRZ_Ctx * private_get_brz_context ();


void
brz_init () {
  Py_Initialize ();
  __brz_context__ = malloc (sizeof (BRZ_Ctx));
  
  __brz_context__->program =
            PyRun_String (__BRZ_PY_PROGRAM__,
                          0,
                          __brz_context__->global,
                          __brz_context__->local);
  
}

void
brz_deinit () {
  
  Py_Finalize ();
  
  free (__brz_context__);
  
}

char *
brz_get_version_str () {
  char * retval = NULL;
  
  
  
  return retval;
}


BRZ_Ctx *
private_get_brz_context () {
  brz_assert_msg (__brz_context__ != NULL, "Context not initalized.");
  
  return __brz_context__;
}
